//dmem.h
//DOS page-aligned memory allocation
//Bryan E. Topp <betopp@betopp.com> 2022

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef DMEM_H
#define DMEM_H

#include <stdint.h>
#include <i86.h>

//Gives the 32-bit linear address of a DOS far pointer in conventional space
#define FP_LINEAR(x) ((((uint32_t)FP_SEG(x)) * 16ull) + ((uint32_t)FP_OFF(x)))

//Initializes DOS memory allocation
void dmem_init(void);

//Allocates page-aligned contiguous memory from DOS (<1MByte).
void far *dmem_alloc(uint32_t nbytes);

#endif //DMEM_H
