//launch.h
//Assembly routines for abusing unreal mode to launch application cores
//Bryan E. Topp <betopp@betopp.com> 2022

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef LAUNCH_H
#define LAUNCH_H

//Prepares to use the LAPIC to send Interprocessor Interrupts.
//Returns 0 on success or nonzero if the CPU isn't in real mode.
int launch_init(void);

//Sends an INIT-SIPI-SIPI sequence to start application cores, executing at the given page of conventional memory.
void launch_go(uint8_t pagenum);

//Sends an INIT but no Startup IPIs to stop application cores.
void launch_stop(void);

//Sends a one-shot interprocessor interrupt to application cores.
void launch_ipi(uint8_t which);

#endif //LAUNCH_H

