//vbe.h
//Video calls for real-mode loop
//Bryan E. Topp <betopp@betopp.com> 2022

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef VBE_H
#define VBE_H

#include <stdint.h>

//Initializes video handling
void vbe_init(void);

//Writes framebuffer addresses to kernel via ringbuffers.
void vbe_handoff(void);

//Changes the displayed buffer to the one at the given physical address.
void vbe_flip(uint32_t paddr);

#endif //VBE_H
