//dring.h
//DOS-to-kernel ringbuffers
//Bryan E. Topp <betopp@betopp.com> 2022

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef DRING_H
#define DRING_H

//Channel numbers that we use - make sure this lines up with the DOS loader
typedef enum dring_channel_e
{
	DRING_CHANNEL_NONE = 0,
	
	DRING_CHANNEL_PANIC,
	
	DRING_CHANNEL_MEMRANGES,
	
	DRING_CHANNEL_ENET0_SEND,
	DRING_CHANNEL_ENET0_RECV,
	
	DRING_CHANNEL_UART0_SEND,
	DRING_CHANNEL_UART0_RECV,
	
	DRING_CHANNEL_VMEMS,
	DRING_CHANNEL_VMODE,
	DRING_CHANNEL_VCURR,
	
	DRING_CHANNEL_INPUT,
	
	DRING_CHANNEL_MAX
	
} dring_channel_t;

//Reads from a ringbuffer
int dring_read(int channel, void *dst, int nbytes);

//Writes to a ringbuffer
int dring_write(int channel, const void *src, int nbytes);

#endif //DRING_H
