//m_panic.c
//Implementation of panic() on DOS-loaded kernel
//Bryan E. Topp <betopp@betopp.com> 2022

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#include "m_panic.h"
#include "dring.h"
#include "shared/kstd.h"

void m_panic(const char *str)
{
	dring_write(DRING_CHANNEL_PANIC, str, strlen(str) + 1);
	while(1) { asm("cli"); asm("hlt"); }
}
