//pspace.h
//Physical space access on AMD64
//Bryan E. Topp <betopp@betopp.com> 2021

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef PSPACE_H
#define PSPACE_H

#include "shared/kstd.h"

//Reads from physical space
uint64_t pspace_read(uint64_t addr);
uint32_t pspace_read32(uint64_t addr);

//Writes to physical space
void pspace_write(uint64_t addr, uint64_t data);
void pspace_write32(uint64_t addr, uint32_t data);

//Clears a frame of physical space
void pspace_clrframe(uint64_t addr);


#endif //PSPACE_H

