//m_cache.h
//Memory model functions per machine
//Bryan E. Topp <betopp@betopp.com> 2022

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef M_CACHE_H
#define M_CACHE_H

#include "../src/kstd.h"

//Ensures that all pending writes are complete.
void m_cache_finish(const void *addr, size_t size);

//Ensures that subsequent reads to the given region return the latest data.
void m_cache_freshen(void *addr, size_t size);

#endif //M_CACHE_H
