//m_enet.h
//Per-machine functions - Ethernet interface
//Bryan E. Topp <betopp@betopp.com> 2022

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef M_ENET_H
#define M_ENET_H

//Attempts to send a frame on the given Ethernet interface.
//Returns the number of bytes sent if the packet was given to hardware.
//Returns a negative error number otherwise.
//len must be in the range 64 to 1500.
int m_enet_send(int which, const char *buf, int len);

//Attempts to receive a frame on the given Ethernet interface.
//Returns the length of the frame received if one was taken from hardware.
//Returns a negative error number otherwise.
//len must be at least 1522.
int m_enet_recv(int which, char *buf, int len);

#endif //M_ENET_H
