//m_frame.h
//Physical memory allocator, per-machine
//Bryan E. Topp <betopp@betopp.com> 2021

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef M_FRAME_H
#define M_FRAME_H

#include "../src/kstd.h"

//Returns the size of physical frame that this machine allocates.
size_t m_frame_size(void);

//Allocates a frame and returns its physical address.
uintptr_t m_frame_alloc(void);

//Frees a frame, returning it to the frames available to allocate.
void m_frame_free(uintptr_t frame);

//Copies contents from one frame to another.
void m_frame_copy(uintptr_t newframe, uintptr_t oldframe);

#endif //M_FRAME_H

