//m_intr.h
//Interrupt control, per-machine functions
//Bryan E. Topp <betopp@betopp.com> 2021

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef M_INTR_H
#define M_INTR_H

#include "../src/kstd.h"

//Enables or disables interrupt handling
void m_intr_ei(bool enable);

//Atomically halts with interrupts enabled, catching immediately any pending interrupts.
void m_intr_halt(void);

//Wakes halted processors.
void m_intr_wake(void);

//Returns the number of milliseconds that have elapsed since the system booted.
int m_intr_ticks(void);

#endif //M_INTR_H
