//m_uart.h
//Per-machine functions - serial ports
//Bryan E. Topp <betopp@betopp.com> 2022

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef M_UART_H
#define M_UART_H

//Attempts to send data on the given UART.
//Returns how many bytes were given to hardware, or a negative error number.
int m_uart_send(int which, const char *buf, int len);

//Attempts to receive data from the given UART.
//Returns how many new bytes were received, or a negative error number.
int m_uart_recv(int which, char *buf, int len);

#endif //M_UART_H
