//m_video.h
//Video output functions, per-machine
//Bryan E. Topp <betopp@betopp.com> 2022

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef M_VIDEO_H
#define M_VIDEO_H

#include "../src/kstd.h"
#include <sc_con.h>

//Returns the physical address of a framebuffer for mapping.
uintptr_t m_video_fbaddr(int idx);

//Returns the size of each framebuffer
size_t m_video_fbsize(void);

//Returns how many framebuffers are suppored
size_t m_video_fbcount(void);

//Returns the format of image stored in each framebuffer
void m_video_fbinfo(_sc_con_fbinfo_t *info_out);

//Enqueues a change in which framebuffer is displayed. Address is given physically.
void m_video_setbuf(uintptr_t bufpaddr);

//Returns which framebuffer is currently displayed.
uintptr_t m_video_getbuf(void);

#endif //M_VIDEO_H

