//con.h
//Console handling in kernel
//Bryan E. Topp <betopp@betopp.com> 2021

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef CON_H
#define CON_H

#include "kstd.h"
#include <sc_con.h>

//Outputs pending keyboard/mouse input. Returns the number of events or a negative error number.
ssize_t con_input(void *buf, ssize_t buflen);

//Primes the console to be stolen by the init process.
void con_steal_prepare(void);

//Releases threads waiting on console input
void con_isr_input(void);

//Returns whether the given process currently has access to the console.
bool con_on(int pid);

#endif //CON_H

