//elf.h
//Handling of ELF format in kernel
//Bryan E. Topp <betopp@betopp.com> 2021

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef ELF_H
#define ELF_H

#include "file.h"
#include "mem.h"
#include "kstd.h"

//Loads the given ELF file into the given memory space.
int elf_load(file_t *file, mem_t *mem, uintptr_t *entry_out);

#endif //ELF_H
