//fb.h
//Framebuffer handling in kernel
//Bryan E. Topp <betopp@betopp.com> 2021

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef FB_H
#define FB_H

#include "kstd.h"
#include <sc.h>

//Initializes framebuffer handling.
void fb_init(void);

//Handles framebuffer update on periodic interrupt 
void fb_isr(void);


//Allocates a framebuffer of the requested size; returns its physical address.
uintptr_t fb_alloc(int size);

//Returns a framebuffer to the allocator
void fb_free(uintptr_t addr);


//Flips to the given buffer on the next vsync (given by physical address).
int fb_flip(uintptr_t addr);


#endif //FB_H

