//kassert.h
//Kernel assertion macro
//Bryan E. Topp <betopp@betopp.com> 2021

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef KASSERT_H
#define KASSERT_H

//Runaround for making a string out of __LINE__ 
#define KASSERT_STR1(x) #x
#define KASSERT_STR2(x) KASSERT_STR1(x)

//Macro for panicking if a condition is false.
#define KASSERT(cond) do { if(!(cond)) { kassert_failed("Failed(" __FILE__ ":" KASSERT_STR2(__LINE__) "):" #cond ); } } while(0)

//Handler for failed assertions
extern void kassert_failed(const char *str);

#endif //KASSERT_H
