//namei.h
//Iterative directory lookups
//Bryan E. Topp <betopp@betopp.com> 2022

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef NAMEI_H
#define NAMEI_H

//Looks up intermediate components of the given path.
//Returns a directory and name, representing the actual link to operate on.
//On success, *dir_out will always be filled, will be locked, and will have 0 references. It must be unlocked by the caller.
int namei(file_t *dir, const char *path, int access, file_t **dir_out, char *name_out256);

#endif //NAMEI_H
