;crti.asm
;Function prologues for init/fini functions in C runtime on AMD64
;Bryan E. Topp <betopp@betopp.com> 2021

;This file is part of Stump; Copyright Bryan E. Topp, 2023.
;Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
;Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
;You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

section .init.i
	
;Make reference to _init_done so it doesn't get GC'd
extern _init_done
dq _init_done
	
;Linked at the beginning of the .init section
global _init
_init:
	push RBP
	mov RBP, RSP
	;...further code added at link time
	
section .fini.i

;Make reference to _fini_done so it doesn't get GC'd
extern _fini_done
dq _fini_done

;Linked at the beginning of the .fini section
global _fini
_fini:
	push RBP
	mov RBP, RSP
	;...further code added at link time
	
