/* user.ld
 * Linker script for userland on AMD64
 * Bryan E. Topp <betopp@betopp.com> 2021
 *
 * This file is part of Stump; Copyright Bryan E. Topp, 2023.
 * Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 * Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 
 */

ENTRY(_crt_entry)

SECTIONS {

	. = 0x10000000 + SIZEOF_HEADERS;

	.text ALIGN(0x4000) :
	{
		*(.header)
		*(.text*)
		*(.note*)
		*(.init.i)
		*(.init)
		*(.init.n)
		*(.fini.i)
		*(.fini)
		*(.fini.n)
		. = ALIGN(0x4000);
		_TEXT_END = .;
	}

	.rodata ALIGN(0x4000) :
	{
		*(.rodata*)
		*(.eh_frame*)
		*(.ARM.exidx)
		. = ALIGN(0x4000);
		_RODATA_END = .;
	}
	
	.data ALIGN(0x4000) :
	{
		*(.data*)
		. = ALIGN(0x4000);
		_DATA_END = .;
	}
	
	.bss ALIGN(0x4000) :
	{
		*(COMMON)
		*(.bss*)
		. = ALIGN(0x4000);
		_BSS_END = .;
	}
}
