//mmlibc/include/endian.h
//Byte-swapping declarations for MMK's libc.
//Bryan E. Topp <betopp@betopp.com> 2023
#ifndef _ENDIAN_H
#define _ENDIAN_H

#include <stdint.h>

#define LITTLE_ENDIAN 1234
#define BIG_ENDIAN 4321
#define BYTE_ORDER LITTLE_ENDIAN

#define __LITTLE_ENDIAN LITTLE_ENDIAN
#define __BIG_ENDIAN BIG_ENDIAN
#define __BYTE_ORDER BYTE_ORDER

uint16_t htobe16(uint16_t h16);
uint16_t htole16(uint16_t h16);
uint16_t be16toh(uint16_t b16);
uint16_t le16toh(uint16_t l16);

uint32_t htobe32(uint32_t h32);
uint32_t htole32(uint32_t h32);
uint32_t be32toh(uint32_t b32);
uint32_t le32toh(uint32_t l32);

uint64_t htobe64(uint64_t h64);
uint64_t htole64(uint64_t h64);
uint64_t be64toh(uint64_t b64);
uint64_t le64toh(uint64_t l64);

uint16_t bswap16(uint16_t b);
uint32_t bswap32(uint32_t b);
uint64_t bswap64(uint64_t b);

#endif // _ENDIAN_H
