//mmlibc/include/glob.h
//Path matching definitions for libc
//Bryan E. Topp <betopp@betopp.com> 2023
#ifndef _GLOB_H
#define _GLOB_H

#include <mmbits/typedef_size.h>

typedef struct _glob_s
{
	size_t gl_pathc;
	char **gl_pathv;
	size_t gl_offs;
} glob_t;

//Like BSD
#define GLOB_APPEND 1
#define GLOB_DOOFFS 2
#define GLOB_ERR 4
#define GLOB_MARK 8
#define GLOB_NOCHECK 16
#define GLOB_NOESCAPE 8192
#define GLOB_NOSORT 32
#define GLOB_ABORTED -2
#define GLOB_NOMATCH -3
#define GLOB_NOSPACE -1

#define GLOB_TILDE 0x0800

//???
#define GLOB_PERIOD 0x10000
#define GLOB_TILDE_CHECK 0x20000

#endif //_GLOB_H
