//mmlibc/include/locale.h
//Locale definitions for libc
//Bryan E. Topp <betopp@betopp.com> 2023
#ifndef _LOCALE_H
#define _LOCALE_H

struct lconv
{
	char *currency_symbol;
	char *decimal_point;
	char frac_digits;
	char *grouping;
	char *int_curr_symbol;
	char int_frac_digits;
	char int_n_cs_precedes;
	char int_n_sep_by_space;
	char int_n_sign_posn;
	char int_p_cs_precedes;
	char int_p_sep_by_space;
	char int_p_sign_posn;
	char *mon_decimal_point;
	char *mon_grouping;
	char *mon_thousands_sep;
	char *negative_sign;
	char n_cs_precedes;
	char n_sep_by_space;
	char n_sign_posn;
	char *positive_sign;
	char p_cs_precedes;
	char p_sep_by_space;
	char p_sign_posn;
	char *thousands_sep;
};

#include <mmbits/define_null.h>

//Like BSD
#define LC_ALL 0
#define LC_COLLATE 1
#define LC_CTYPE 2
#define LC_MESSAGES 6
#define LC_MONETARY 3
#define LC_NUMERIC 4
#define LC_TIME 5

#define LC_COLLATE_MASK 1
#define LC_CTYPE_MASK 2
#define LC_MESSAGES_MASK 32
#define LC_MONETARY_MASK 4
#define LC_NUMERIC_MASK 8
#define LC_TIME_MASK 16

#define LC_ALL_MASK 63
#define LC_GLOBAL_LOCALE -1

#include <mmbits/typedef_locale.h>

locale_t duplocale(locale_t);
void freelocale(locale_t);
struct lconv *localeconv(void);
locale_t newlocale(int, const char *, locale_t);
char *setlocale(int, const char *);
locale_t uselocale (locale_t);

#endif //_LOCALE_H
