//mmlibc/include/mmbits/struct_dirent.h
//Fragment for building C standard headers.
//Bryan E. Topp <betopp@betopp.com> 2020
#ifndef _STRUCT_DIRENT_H
#define _STRUCT_DIRENT_H

#include <mmbits/typedef_ino.h>
#include <mmbits/define_modes.h>
#include <mmbits/typedef_mode.h>

struct dirent
{
	ino_t d_ino; //File serial number
	mode_t d_type; //Mode with permission bits masked out (for Linux compatibility)
	char d_name[]; //Filename string of entry
};

//For Linux compatibility with d_type field
#define DT_DIR S_IFDIR
#define DT_REG S_IFREG
#define DT_LNK S_IFLNK

#endif //_STRUCT_DIRENT_H
