//mmlibc/include/regex.h
//Regular expression declarations for MMK's libc
//Bryan E. Topp <betopp@betopp.com> 2023
#ifndef _REGEX_H
#define _REGEX_H

#include <mmbits/typedef_regex.h>
#include <mmbits/typedef_size.h>
#include <mmbits/typedef_regoff.h>
#include <mmbits/typedef_regmatch.h>

//Like BSD
#define REG_EXTENDED 1
#define REG_ICASE 2
#define REG_NOSUB 4
#define REG_NEWLINE 8

#define REG_NOTBOL 1
#define REG_NOTEOL 2

#define REG_OK 0 //Used by musl regex code
#define REG_NOMATCH 1
#define REG_BADPAT 2
#define REG_ECOLLATE 3
#define REG_ECTYPE 4
#define REG_EESCAPE 5
#define REG_ESUBREG 6
#define REG_EBRACK 7
#define REG_EPAREN 8
#define REG_EBRACE 9
#define REG_BADBR 10
#define REG_ERANGE 11
#define REG_ESPACE 12
#define REG_BADRPT 13

int regcomp(regex_t * restrict preg, const char * restrict pattern, int cflags);
int regexec(const regex_t * restrict preg, const char * restrict string, size_t nmatch, regmatch_t pmatch[restrict], int eflags);
size_t regerror(int errcode, const regex_t * restrict preg, char * restrict errbuf, size_t errbuf_size);
void regfree(regex_t *preg);

#endif //_REGEX_H
