//mmlibc/include/sched.h
//Scheduling definitions for libc
//Bryan E. Topp <betopp@betopp.com> 2023
#ifndef _SCHED_H
#define _SCHED_H

#include <mmbits/struct_sched_param.h>
#include <mmbits/struct_timespec.h>
#include <mmbits/typedef_pid.h>

#define SCHED_FIFO 1
#define SCHED_RR 3
#define SCHED_OTHER 2

int sched_yield(void);

int sched_get_priority_max(int);
int sched_get_priority_min(int);
int sched_getparam(pid_t, struct sched_param *);
int sched_getscheduler(pid_t);
int sched_rr_get_interval(pid_t, struct timespec *);
int sched_setparam(pid_t, const struct sched_param *);
int sched_setscheduler(pid_t, int, const struct sched_param *);

#endif //_SCHED_H
