//mmlibc/include/wchar.h
//Wide character definitions for MMK's libc
//Bryan E. Topp <betopp@betopp.com> 2020
#ifndef _WCHAR_H
#define _WCHAR_H

#include <mmbits/typedef_wchar.h>
#include <mmbits/typedef_size.h>

#include <mmbits/define_weof.h>

#define WCHAR_MAX __INT32_MAX__
#define WCHAR_MIN __INT32_MIN__

//We intentionally don't define a lot of these.
//Wide characters are a shitty idea and you shouldn't use them. Get UTF-8 instead.

typedef int mbstate_t; //UTF-8 doesn't need conversion state

size_t wcrtomb(char * restrict s, wchar_t c, mbstate_t * restrict ps);
int wcwidth(wchar_t wc);

#endif //_WCHAR_H
