//assert.c
//Assertion failure in libc
//Bryan E. Topp <betopp@betopp.com> 2021

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

char assert_buffer[256];

void _assertion_failed(const char *cond, const char *file, const char *func, int line)
{
	while(1) { }
	snprintf(assert_buffer, sizeof(assert_buffer)-1, "Assertion failed: %s in %s at %s:%d.\n", cond, func, file, line);
	fprintf(stderr, assert_buffer);
	abort();
}
