//confstr.c
//Implementation of confstr for libc
//Bryan E. Topp <betopp@betopp.com> 2021

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#include <unistd.h>
#include <string.h>
#include <errno.h>

size_t confstr(int name, char *buf, size_t len)
{
	switch(name)
	{
		case _CS_PATH:
		{
			static const char *path = "/bin";
			strncpy(buf, "/bin", len);
			return strlen(path)+1;
		}
		default:
		{
			errno = EINVAL;
			return 0;
		}
	}
}
