//locale.c
//Locale conversion in libc
//Bryan E. Topp <betopp@betopp.com> 2023

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#include <locale.h>
#include <errno.h>
#include <langinfo.h>
#include <iconv.h>
#include <string.h>

char *setlocale(int category, const char *locale)
{
	(void)category;
	(void)locale;
	errno = ENOSYS;
	return NULL;
}

locale_t newlocale(int mask, const char * locale, locale_t base)
{
	(void)mask;
	(void)locale;
	(void)base;
	errno = ENOSYS;
	return NULL;
}

locale_t uselocale(locale_t locale)
{
	(void)locale;
	errno = ENOSYS;
	return NULL;
}

size_t iconv(iconv_t cd, char ** restrict src, size_t * restrict srcleft, char ** restrict dst, size_t * restrict dstleft)
{
	(void)cd;
	(void)src;
	(void)srcleft;
	(void)dst;
	(void)dstleft;
	errno = ENOSYS;
	return (size_t)-1;
}

iconv_t iconv_open(const char *dstname, const char *srcname)
{
	(void)dstname;
	(void)srcname;
	errno = ENOSYS;
	return NULL;
}

char *nl_langinfo(nl_item item)
{
	if(!memcmp(&item, &CODESET, sizeof(item)))
		return "UTF-8";
	
	errno = ENOSYS;
	return "";
}
