//sched.c
//Scheduling stubs for libc
//Bryan E. Topp <betopp@betopp.com> 2023

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#include <sched.h>
#include <errno.h>

int sched_get_priority_max(int policy)
{
	(void)policy;
	errno = ENOSYS;
	return -1;
}

int sched_get_priority_min(int policy)
{
	(void)policy;
	errno = ENOSYS;
	return -1;
}

int sched_setscheduler(pid_t pid, int policy, const struct sched_param *param)
{
	(void)pid;
	(void)policy;
	(void)param;
	errno = ENOSYS;
	return -1;
}

int sched_getscheduler(pid_t pid)
{
	(void)pid;
	errno = ENOSYS;
	return -1;
}

int sched_setparam(pid_t pid, const struct sched_param *param)
{
	(void)pid;
	(void)param;
	errno = ENOSYS;
	return -1;
}

int sched_getparam(pid_t pid, struct sched_param *param)
{
	(void)pid;
	(void)param;
	errno = ENOSYS;
	return -1;
}
