//spl.h
//Spinlocks for libc
//Bryan E. Topp <betopp@betopp.com> 2021

//This file is part of Stump; Copyright Bryan E. Topp, 2023.
//Stump is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
//Stump is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
//You should have received a copy of the GNU General Public License along with Stump. If not, see <https://www.gnu.org/licenses/>. 

#ifndef _SPL_H
#define _SPL_H

//Data for spinlock
typedef volatile uint64_t _spl_t;

//Locks the given spinlock.
void _spl_lock(_spl_t *spl);

//Unlocks the given spinlock.
void _spl_unlock(_spl_t *spl);

#endif //_SPL_H
